<template>
  <LayoutMain>
    <section>
      <b-container>
        <b-row align-h="center">
          <b-col cols="12">
            <TitleShape title="Gestor de cartas" />
          </b-col>
        </b-row>
      </b-container>
      <div class="color-wrapper">
      <b-container>
        <b-row class="text-right">
          <!-- FILTER -->
          <b-col lg="6" class="my-1">
            <b-form-group label="Buscador" label-cols-sm="3" label-align-sm="right" label-size="sm" label-for="filterInput" class="mb-0">
              <b-input-group size="sm">
                <b-form-input v-model="filter"  :debounce=filterDebounce type="search" id="filterInput" placeholder="Nombre de la carta"></b-form-input>
                <b-input-group-append>
                  <b-button :disabled="!filter" @click="filter = ''">Clear</b-button>
                </b-input-group-append>
              </b-input-group>
            </b-form-group>
          </b-col>
          <!-- FIN FILTER -->
          <b-col cols="12">
          <router-link :to="{ name: 'admin.game.category.card.create' }" v-slot="{ href, navigate }" >
            <a :href="href" @click="navigate" class="btn btn-primary">Crear carta
              </a>
          </router-link>
          </b-col>
        </b-row>
        <b-row align-h="center">
          <b-col cols="12">
            <b-table :items="itemsProvider" :busy="isLoading" class="mt-3" outlined id="card-table" :current-page="currentPage"
            :per-page="perPage" :fields="fields" :filter="filter"   :sort-by.sync="sortBy" :sort-desc.sync="sortDesc">
              <template #table-busy>
                <div class="text-center text-danger my-2">
                  <b-spinner class="align-middle"></b-spinner>
                  <strong>Loading...</strong>
                </div>
              </template>
              <!-- COLUMNA DE EDICION -->
              <template #cell(actions)="row">
                <!-- BOTON EDITAR -->
                <router-link :to="{ name: 'admin.game.category.card.edit', params: { category_id: row.item.category_id, card_id: row.item.id } }" v-slot="{ href, navigate }" >
                  <a :href="href" @click="navigate" class="mr-3" title="Editar carta">
                    <eva-icon name=edit-2-outline width="1.5rem" height="1.5rem" animation="pulse"></eva-icon>
                  </a>
                </router-link>
                <!-- BOTON BORRAR -->
                <a href="#" @click="showDeleteModal(row.item, row.index, $event.target)" title="Borrar carta">
                    <eva-icon name=trash-2-outline width="1.5rem" height="1.5rem" animation="pulse"></eva-icon>
                  </a>               
                
                <!-- INFOMODAL -->
              </template>
            </b-table>
             <b-pagination 
              v-model="currentPage"
              :total-rows="rows"
              :per-page="perPage"
              aria-controls="card-table"
            ></b-pagination>
          </b-col>
        </b-row>

        <b-modal :id="deleteModal.id" :title="deleteModal.title" @hide="resetDeleteModal" @ok="handleDelete">    
          Confirma para eliminar la carta {{deleteModal.item.title}}
        </b-modal>
      </b-container>
      </div>
      <b-container  class="mt-3">
        <b-row>
          <b-col cols="6">
          <b-button size="lg" v-on:click="$router.go(-1)" variant="secondary">Volver</b-button>
          </b-col>
        </b-row>
      </b-container>
    </section>
  </LayoutMain>
</template>

<script>
// @ is an alias to /src
import LayoutMain from "@/components/layouts/Main.vue";
import TitleShape from "@/components/TitleShape.vue";
import SingleSpecial from "@/components/SingleSpecial.vue";
import { mapState, mapGetters } from "vuex";

export default {
  name: "acount",
  components: {
    LayoutMain,
    TitleShape,
    SingleSpecial
  },
  props: ["category_id"],
  data() {
      return {
        rows: null,
        categories: [],
        perPage: 15,
        sortBy: 'title',
        sortDesc: false,
        filter: null,
        filterDebounce: 500,
        currentPage: 1,
        fields: [
          { key: 'id', label: 'id', sortable: true},
          { key: 'title', label: 'Título', sortable: true},
          { key: 'year', label: 'Año', sortable: true},
          { key: 'updated_at', label: 'Actualizado', sortable: true, 
            formatter: (value, key, item) => {
              return new Date(value).toISOString()
            }
          },
          { key: 'actions', label: 'Acciones', class: 'text-center' },          
        ],
        deleteModal: {
          id: 'delete-modal',
          title: '',
          item: ''
        }
      }
  },
  computed: {
    //Mapeo los getters del módulo auth para poder emplear sus funciones.
    ...mapGetters("category", ["isLoading"]),
  },
  methods: {
    itemsProvider(ctx, callback) { // <- callback needs to be added here
      let page =  ctx.currentPage
      let perPage =  ctx.perPage
      // callback([])
      let sortBy = ctx.sortBy
      let sortDesc = ctx.sortDesc
      let filter = ctx.filter
      this.$store.dispatch('category/cards', {id:this.category_id,page, perPage, sortBy, sortDesc, filter}).then(resp => {
        const items = resp.data
        this.rows = resp.meta.total
        this.perPage = resp.meta.per_page
        this.currentPage = resp.meta.current_page
        callback(items)
      }).catch(error => {
        callback([])
        console.debug(error)      
      });
      return null
    },
    //INFOMODAL
    showDeleteModal(item, index, button) {
        this.deleteModal.title = 'Borrar carta'
        this.deleteModal.item = item
        this.$root.$emit('bv::show::modal', this.deleteModal.id, button)
      },
      //NO CREO QUE SEA NECESARIO
      resetDeleteModal() {
        this.deleteModal.title = ''
        this.deleteModal.item = ''
      },
      handleDelete(bvModalEvt) {
        // Prevent modal from closing
        bvModalEvt.preventDefault()        
        this.$store.dispatch('card/delete', {id: this.deleteModal.item.id}).then(resp => {
          this.$bvModal.hide(this.deleteModal.id)
           this.$root.$bvToast.toast(`Carta eliminada con éxito`, {
            title: 'Eliminado',
            autoHideDelay: 5000,
            variant: 'success'
          })    
          this.$root.$emit('bv::refresh::table','card-table')       
        })
      }
  }
};
</script>